.text

.globl remap
remap:
	move	$r9, $lp
#ifdef __NDS32_N1213_43U1H__    /* AG101 */
	bal	2f
relo_base:
	move	$r0, $lp
#else
relo_base:
	mfusr	$r0, $pc
#endif

	/* relocation, copy ROM code to SDRAM(current is at 0x10000000) */
	li	$r4, 0x10000000
	li	$r5, 0x0
	la	$r1, relo_base
	sub	$r2, $r0, $r1
	sethi	$r6, hi20(_end)
	ori	$r6, $r6, lo12(_end)
	add	$r6, $r6, $r2
1:
	lwi     $r7, [$r5]
	swi     $r7, [$r4]
	addi    $r5, $r5, #4
	addi    $r4, $r4, #4
	blt     $r5, $r6, 1b

	/* Remapping */
	li  $r0, 0x90300000 /* SDRAMC Register */
	li	$r1, 0x00001100 /* Bank Enable, BASE = 0x100 for haddr[31:20] of the AHB address bus. */
	swi	$r1, [$r0+0x10] /* External Bank Configuration Registers */
	
	li	$r1, 0x0
	swi	$r1, [$r0+0x14] /* External Bank Configuration Registers */
	swi	$r1, [$r0+0x18] /* External Bank Configuration Registers */
	swi	$r1, [$r0+0x1c] /* External Bank Configuration Registers */
	li	$r1, 0x00001000
	swi	$r1, [$r0+0x10] /* Bank Disable, BASE = 0x100 for haddr[31:20] of the AHB address bus. */

	li	$r0, 0x90100088 
	lwi	$r1, [$r0]     
	ori	$r1, $r1, 0x1
	swi	$r1, [$r0]     /*When writing a 1 to this bit, the base/size configuration 
	                     of AHB slaves 4 (ROM) and 6 (SDRAM) will be interchanged. */

	li	$r0, 0x90200000 /* SMC Register */
#ifdef __NDS32_N1213_43U1H__    /* AG101 */
	li	$r1, 0x10400062
	swi	$r1, [$r0+0x8]
	li	$r1, 0x000ff3ff
	swi     $r1, [$r0+0xc]
#else
	li	$r1, 0x10400062 /*64 MB, Memory data width is 32 */
	swi	$r1, [$r0]
#endif

	move	$lp, $r9
2:
    	ret