#include "ag101.h"

/*int uart_rx_buffer_data[20] __attribute__ ((section ("UART_RXBUFFER")));

static void uart_rx_buffer_func(void){
    puts("UART_RXBUFFER\n");
}*/


uart_init(void)
{
    /* mode select (UART) */	
	outw(UART_BASE + UART_MDR_OFFSET, inw(UART_BASE + UART_MDR_OFFSET) & ~(0x3));
	/* Set DLAB to 1 */
	outw(UART_BASE + UART_LCR_OFFSET, inw(UART_BASE + UART_LCR_OFFSET)|0x80);
	/* DLL = 0x18*/
	outw(UART_BASE + 0x00, 0x18); 
	/* DLM = 0 */  
	outw(UART_BASE + 0x04, 0x0);   	
    /* baud 38400 , LCR: Length 8, no parity, 1 stop bit.*/
	outw(UART_BASE + UART_LCR_OFFSET, 0x03); 
	/* FCR: Enable FIFO, reset TX and RX. */
	outw(UART_BASE + UART_FCR_OFFSET, 0x07); 
}

void bsp_outbyte(unsigned char c)
{
	while (inw(UART_BASE+0x08) & 0x10); // tx fifo full
	outw(UART_BASE+0x00,c); 
}

/*static inline void puts(const char *s)
{
        volatile unsigned *status = (volatile unsigned *)(UART_PA_BASE+SERIAL_LSR);
	while (*s) {
                while ((*status & SERIAL_LSR_THRE)==0);

		*(volatile unsigned*)(UART_PA_BASE+SERIAL_THR) = (unsigned)*s;

		if (*s == '\n') {
                        while ((*status & SERIAL_LSR_THRE)==0);
                        *(volatile unsigned*)(UART_PA_BASE+SERIAL_THR) = '\r';
		}
		s++;
	}
}*/
