#define UART_PA_BASE	0x99600000

#define SERIAL_THR                     	0x00
#define SERIAL_LSR                      0x14
#define SERIAL_LSR_THRE                 0x20

static inline void puts(const char *s)
{
        volatile unsigned *status = (volatile unsigned *)(UART_PA_BASE+SERIAL_LSR);
	while (*s) {
                while ((*status & SERIAL_LSR_THRE)==0);

		*(volatile unsigned*)(UART_PA_BASE+SERIAL_THR) = (unsigned)*s;

		if (*s == '\n') {
                        while ((*status & SERIAL_LSR_THRE)==0);
                        *(volatile unsigned*)(UART_PA_BASE+SERIAL_THR) = '\r';
		}
		s++;
	}
}
